searchNodes=[{"doc":"Runs tasks from the Surgex.Refactor module","ref":"Mix.Tasks.Surgex.Refactor.html","title":"Mix.Tasks.Surgex.Refactor","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Surgex.Refactor.html#run/1","title":"Mix.Tasks.Surgex.Refactor.run/1","type":"function"},{"doc":"Main Surgex OTP application that calls patches configured for running and hibernates itself.","ref":"Surgex.Application.html","title":"Surgex.Application","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Surgex.Application.html#child_spec/1","title":"Surgex.Application.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Surgex.Application.html#init/1","title":"Surgex.Application.init/1","type":"function"},{"doc":"Tools for working with Ecto changesets.","ref":"Surgex.Changeset.html","title":"Surgex.Changeset","type":"module"},{"doc":"Builds Jabbax document that describes changeset errors.","ref":"Surgex.Changeset.html#build_errors_document/1","title":"Surgex.Changeset.build_errors_document/1","type":"function"},{"doc":"Tools for moving data between PostgreSQL databases and tables.The following tools are available:Surgex.DataPipe.FollowerSync: waits for a slave synchronization with a remote masterSurgex.DataPipe.ForeignDataWrapper: configures a FDW linkage between two reposSurgex.DataPipe.TableSync: ETLs data from one database or table into anotherSurgex.DataPipe.RepoProxy: Proxies repo calls depending on replication needsUsageA common scenario may be to wait for a message or event coming from an external service that has just made a change in an OLTP master database (D1) which we can access via a read-only slave (D2) for puproses of efficient ETL into our own OLAP database (D3). Let's see what steps and what tools from this module are involved in such a data pipe.First, since we're using slave that replicates data from master with a delay, we may want to wait for it to catch up with a master to a point at which the event was triggered. In order to do that, the external service should include the current log location (lsn) of D1 in the event. We can use that to wait for D2 to catch up:%{lsn: d1_lsn} = external_event FollowerSync.call(D2Repo, d1_lsn)Then, we may connect our D3 database to D2 via an efficient PostgreSQL FDW link in order for data to flow directly between databases without having to load them into app memory:ForeignDataWrapper.call(D3Repo, D2Repo)Finally, we may synchronize data between two repos using a native Ecto syntax:query = D2Sale |&gt; where(...) |&gt; select(...) |&gt; ForeignDataWrapper.prefix(D2Repo) TableSync.call(D3Repo, query, D3FactSale)That's it. You now have an up-to-date copy of reduced data from OLTP master in your OLAP database.","ref":"Surgex.DataPipe.html","title":"Surgex.DataPipe","type":"module"},{"doc":"Acquires a PostgreSQL slave synchronization with a remote master.UsageIt can be configured globally or per repo as follows:config :surgex, follower_sync_enabled: true, follower_sync_timeout: 15_000, follower_sync_interval: 1_000 config :my_project, MyProject.MyRepo, # ... follower_sync_enabled: true, follower_sync_timeout: 15_000, follower_sync_interval: 1_000As a convenience versus calling Surgex.DataPipe.FollowerSync.call/2 all the time, it can be used in a repo module as follows:defmodule MyProject.MyRepo do use Surgex.DataPipe.FollowerSync end MyProject.MyRepo.ensure_follower_sync(lsn)Refer to Surgex.DataPipe for a complete data pipe example.","ref":"Surgex.DataPipe.FollowerSync.html","title":"Surgex.DataPipe.FollowerSync","type":"module"},{"doc":"Waits for a given slave repo's sync up to specific remote master's lsn.","ref":"Surgex.DataPipe.FollowerSync.html#call/2","title":"Surgex.DataPipe.FollowerSync.call/2","type":"function"},{"doc":"Configures a PostgreSQL Foreign Data Wrapper linkage between two repos.Specifically, it executes the following steps:adds postgres_fdw extension to local repo(re)creates server and user mapping based on current remote repo's configcopies remote repo's schema to local repo (named with underscored repo module name)Everything is executed in one transaction, so it's safe to use while existing transactions that depend on connection to foreign repo and its schema are running in the system (based on https://robots.thoughtbot.com/postgres-foreign-data-wrapper).UsageRefer to Surgex.DataPipe for a complete data pipe example.","ref":"Surgex.DataPipe.ForeignDataWrapper.html","title":"Surgex.DataPipe.ForeignDataWrapper","type":"module"},{"doc":"Links source repo to a given foreign repo.","ref":"Surgex.DataPipe.ForeignDataWrapper.html#init/2","title":"Surgex.DataPipe.ForeignDataWrapper.init/2","type":"function"},{"doc":"","ref":"Surgex.DataPipe.ForeignDataWrapper.html#init_script/3","title":"Surgex.DataPipe.ForeignDataWrapper.init_script/3","type":"function"},{"doc":"Puts a foreign repo prefix (aka. schema) in a given Repo query.After calling this function, a given query will target tables from the previously linked repo instead of Repo.","ref":"Surgex.DataPipe.ForeignDataWrapper.html#prefix/2","title":"Surgex.DataPipe.ForeignDataWrapper.prefix/2","type":"function"},{"doc":"","ref":"Surgex.DataPipe.ForeignDataWrapper.html#update_script/3","title":"Surgex.DataPipe.ForeignDataWrapper.update_script/3","type":"function"},{"doc":"Executes system-level PostgreSQL queries (server version, WAL status etc).","ref":"Surgex.DataPipe.PostgresSystemUtils.html","title":"Surgex.DataPipe.PostgresSystemUtils","type":"module"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#full_version_string/1","title":"Surgex.DataPipe.PostgresSystemUtils.full_version_string/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#get_current_wal_lsn/1","title":"Surgex.DataPipe.PostgresSystemUtils.get_current_wal_lsn/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#get_current_wal_lsn_function/1","title":"Surgex.DataPipe.PostgresSystemUtils.get_current_wal_lsn_function/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#get_last_wal_replay_lsn/1","title":"Surgex.DataPipe.PostgresSystemUtils.get_last_wal_replay_lsn/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#get_last_wal_replay_lsn_function/1","title":"Surgex.DataPipe.PostgresSystemUtils.get_last_wal_replay_lsn_function/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#get_lsn/2","title":"Surgex.DataPipe.PostgresSystemUtils.get_lsn/2","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#lsn_valid?/1","title":"Surgex.DataPipe.PostgresSystemUtils.lsn_valid?/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#version/1","title":"Surgex.DataPipe.PostgresSystemUtils.version/1","type":"function"},{"doc":"","ref":"Surgex.DataPipe.PostgresSystemUtils.html#version_match?/2","title":"Surgex.DataPipe.PostgresSystemUtils.version_match?/2","type":"function"},{"doc":"Proxies repo calls depending on replication needs.","ref":"Surgex.DataPipe.RepoProxy.html","title":"Surgex.DataPipe.RepoProxy","type":"module"},{"doc":"Extracts and transforms data from one PostgreSQL table into another.UsageRefer to Surgex.DataPipe for a complete data pipe example.","ref":"Surgex.DataPipe.TableSync.html","title":"Surgex.DataPipe.TableSync","type":"module"},{"doc":"Synchronizes the given repository's table with data fetched using a specified query.The synchronization is done via a single SQL query by utilizing the WITH statement. It first executes INSERT .. ON CONFLICT (called &quot;upserting&quot;) to insert and update new rows, followed by DELETE .. WHERE that removes old entries that didn't appear in the input query.Returns a tuple with a number of upserts (inserts + updates) and a number of deletions.","ref":"Surgex.DataPipe.TableSync.html#call/4","title":"Surgex.DataPipe.TableSync.call/4","type":"function"},{"doc":"Cleans tables in a database represented by an Ecto repo.UsageHere's a basic example:Surgex.DatabaseCleaner.call(MyProject.Repo) Surgex.DatabaseCleaner.call(MyProject.Repo, method: :delete_all) Surgex.DatabaseCleaner.call(MyProject.Repo, only: ~w(posts users)) Surgex.DatabaseCleaner.call(MyProject.Repo, only: [Post, User]) Surgex.DatabaseCleaner.call(MyProject.Repo, except: [Project])This module may come in handy as a tool for configuring integration tests. You may use it globally if you want to clean before all tests as following:setup do :ok = Ecto.Adapters.SQL.Sandbox.checkout(MyProject.Repo) # ... Surgex.DatabaseCleaner.call(MyProject.Repo) :ok endAlso, in order not to ruin test performance and the general experience of the Ecto sandbox, you may want to clean repo only after those tests that are tagged not to run in the sandbox. It can be achieved via the following on_exit callback:setup do if tags[:sandbox] == false do :ok = Ecto.Adapters.SQL.Sandbox.checkout(MyProject.Repo, sandbox: false) on_exit(fn -&gt; :ok = Ecto.Adapters.SQL.Sandbox.checkout(MyProject.Repo, sandbox: false) Surgex.DatabaseCleaner.call(MyProject.Repo) end) else # ... end :ok end","ref":"Surgex.DatabaseCleaner.html","title":"Surgex.DatabaseCleaner","type":"module"},{"doc":"Cleans selected or all tables in given repo using specified method.Optionsmethod: one of :truncate (default), :delete_allonly: cleans specified tables/schemas (defaults to all tables)except: cleans all tables/schemas except specified ones","ref":"Surgex.DatabaseCleaner.html#call/2","title":"Surgex.DatabaseCleaner.call/2","type":"function"},{"doc":"Utilities for creating date times.","ref":"Surgex.DateTime.html","title":"Surgex.DateTime","type":"module"},{"doc":"Create UTC or time-zone date time given a date and seconds (from midnight) offset.Examples iex&gt; Surgex.DateTime.date_and_offset_to_datetime(~D{2021-10-07}, 5400)","ref":"Surgex.DateTime.html#date_and_offset_to_datetime/3","title":"Surgex.DateTime.date_and_offset_to_datetime/3","type":"function"},{"doc":"Official style guide for Elixir and Phoenix projects at Surge Ventures.NOTE: Deprecated in favor of https://github.com/surgeventures/elixir.The rules in this guide aim to provide a consistent, convention-driven coding experience and an easily readable, long-term maintainable code as a result. It's divided into the following modules:Surgex.Guide.CodeStyle: basic code style and formatting guidelinesSurgex.Guide.SoftwareDesign: higher level application design and engineering guidelinesHere's what you can expect from this guide:Elixir-friendly experience: rules are written as Elixir functions with @doc clauses and compiled by ExDoc to a documentation easily browsable by anyone familiar to HexDocsOne-line summary for each rule: each rule's @doc starts with a descriptive one-line summary, which is compiled into a clean list of rules (the Summary section)Reasoning for every rule: it's only fair to make the reasoning behind the rules clear for those who use them and leave the door open for discussions and improvementsExamples for every rule: even for the simplest rules, an examples of proper and inproper use are provided in order to make it clear what it's all about in a matter of secondsAbove all rules, use your common sense to solve every coding situation in a way that's consistent, readable and maintainable. Follow your instincts and keep making this guide better in places where it lacks.","ref":"Surgex.Guide.html","title":"Surgex.Guide","type":"module"},{"doc":"Basic code style and formatting guidelines.","ref":"Surgex.Guide.CodeStyle.html","title":"Surgex.Guide.CodeStyle","type":"module"},{"doc":"Aliases should be preferred over using full module name.ReasoningAliasing modules makes code more compact and easier to read. They're even more beneficial as the number of uses of aliased module grows.That's of course assuming they don't override other used modules or ones that may be used in the future (such as stdlib's IO or similar).ExamplesPreferred:def create(params) alias Toolbox.Creator params |&gt; Creator.build() |&gt; Creator.call() |&gt; Toolbox.IO.write() endNot so DRY:def create(params) params |&gt; Toolbox.Creator.build() |&gt; Toolbox.Creator.call() |&gt; Toolbox.IO.write() endOverriding standard library:def create(params) alias Toolbox.IO params |&gt; Toolbox.Creator.build() |&gt; Toolbox.Creator.call() |&gt; IO.write() end","ref":"Surgex.Guide.CodeStyle.html#alias_usage/0","title":"Surgex.Guide.CodeStyle.alias_usage/0","type":"function"},{"doc":"Multi-line calculations should be indented by one level for assignment.ReasoningHorizontal alignment is something especially tempting in Elixir programming as there are many operators and structures that look cool when it gets applied. In particular, pipe chains only look good when the pipe &quot;comes out&quot; from the initial value. In order to achieve that in assignment, vertical alignment is often overused.The issue is with future-proofness of such alignment. For instance, it may easily get ruined without developer's attention in typical find-and-replace sessions that touch the name on the left side of = sign.Hence this rule, which is about inserting a new line after the = and indenting the right side calculation by one level.ExamplesPreferred:user = User |&gt; build_query() |&gt; apply_scoping() |&gt; Repo.one()Cool yet not so future-proof:user = User |&gt; build_query() |&gt; apply_scoping() |&gt; Repo.one()Find-and-replace session result on the above:authorized_user = User |&gt; build_query() |&gt; apply_scoping() |&gt; Repo.one()","ref":"Surgex.Guide.CodeStyle.html#assignment_indentation/0","title":"Surgex.Guide.CodeStyle.assignment_indentation/0","type":"function"},{"doc":"Vertical blocks should be preferred over horizontal blocks.ReasoningThere's often more than one way to achieve the same and the difference is in fitting things horizontally through indentation vs vertically through function composition. This rule is about preference of the latter over the former in order to avoid crazy indentation, have more smaller functions, which makes for a code easier to understand and extend.ExamplesToo much crazy indentation to fit everything in one function:defp map_array(array) do array |&gt; Enum.uniq |&gt; Enum.map(fn array_item -&gt; if is_binary(array_item) do array_item &lt;&gt; &quot; (changed)&quot; else array_item + 1 end end) endPreferred refactor of the above:defp map_array(array) do array |&gt; Enum.uniq |&gt; Enum.map(&amp;map_array_item/1) end defp map_array_item(array_item) when is_binary(array_item), do: array_item &lt;&gt; &quot; (changed)&quot; defp map_array_item(array_item), do: array_item + 1","ref":"Surgex.Guide.CodeStyle.html#block_alignment/0","title":"Surgex.Guide.CodeStyle.block_alignment/0","type":"function"},{"doc":"Indentation blocks must never start or end with blank lines.ReasoningThere's no point in adding additional vertical spacing since we already have horizontal padding increase/decrease on block start/end.ExamplesPreferred:def parent do nil endWasted line:def parent do nil end","ref":"Surgex.Guide.CodeStyle.html#block_inner_spacing/0","title":"Surgex.Guide.CodeStyle.block_inner_spacing/0","type":"function"},{"doc":"Indentation blocks should be padded from surrounding code with single blank line.ReasoningThere are probably as many approaches to inserting blank lines between regular code as there are developers, but the common aim usually is to break the heaviest parts into separate &quot;blocks&quot;. This rule tries to highlight one most obvious candidate for such &quot;block&quot; which is... an actual block.Since blocks are indented on the inside, there's no point in padding them there, but the outer parts of the block (the line where do appears and the line where end appears) often include a key to a reasoning about the whole block and are often the most important parts of the whole parent scope, so it may be beneficial to make that part distinct.In case of Elixir it's even more important, since block openings often include non-trivial destructuring, pattern matching, wrapping things in tuples etc.ExamplesPreferred (there's blank line before the Enum.map block since there's code (array = [1, 2, 3]) in parent block, but there's no blank line after that block since there's no more code after it):def parent do array = [1, 2, 3] Enum.map(array, fn number -&gt; number + 1 end) endObfuscated block:def parent do array = [1, 2, 3] big_numbers = Enum.map(array, fn number -&gt; number + 1 end) big_numbers ++ [5, 6, 7] end","ref":"Surgex.Guide.CodeStyle.html#block_outer_spacing/0","title":"Surgex.Guide.CodeStyle.block_outer_spacing/0","type":"function"},{"doc":"There must be no space put before }, ] or ) and after {, [ or ( brackets.ReasoningIt's often tempting to add inner padding for tuples, maps, lists or function arguments to give those constructs more space to breathe, but these structures are distinct enough to be readable without it. They may actually be more readable without the padding, because this rule plays well with other spacing rules (like comma spacing or operator spacing), making expressions that combine brackets and operators have a distinct, nicely parse-able &quot;rhythm&quot;.Also, when allowed to pad brackets, developers tend to add such padding inconsistently - even between opening and ending in single line. This gets even worse once a different developer modifies such code and has a different approach towards bracket spacing.Lastly, it keeps pattern matchings more compact and readable, which invites developers to utilize this wonderful Elixir feature to the fullest.ExamplesPreferred:def func(%{first: second}, [head | tail]), do: nilEverything padded and unreadable (no &quot;rhythm&quot;):def func( %{ first: second }, [ head | tail ] ), do: nilInconsistencies:def func( %{first: second}, [head | tail]), do: nil","ref":"Surgex.Guide.CodeStyle.html#bracket_spacing/0","title":"Surgex.Guide.CodeStyle.bracket_spacing/0","type":"function"},{"doc":"Single space must be put after commas.ReasoningIt's a convention that passes through many languages - it looks good and so there's no reason to make an exception for Elixir on this one.ExamplesPreferred:fn(arg, %{first: first, second: second}), do: nilThree creative ways to achieve pure ugliness by omitting comma between arguments, map keys or before inline do:fn(arg,%{first: first,second: second}),do: nil","ref":"Surgex.Guide.CodeStyle.html#comma_spacing/0","title":"Surgex.Guide.CodeStyle.comma_spacing/0","type":"function"},{"doc":"Config calls should be placed in alphabetical order, with modules over atoms.ReasoningProvides obvious and predictable placement of specific config calls.ExamplesPreferred:config :another_package, key: value config :my_project, MyProject.A, key: &quot;value&quot; config :my_project, MyProject.B, key: &quot;value&quot; config :my_project, :a, key: &quot;value&quot; config :my_project, :b, key: &quot;value&quot; config :package, key: &quot;value&quot;Modules wrongly mixed with atoms and internal props wrongly before external ones:config :my_project, MyProject.A, key: &quot;value&quot; config :my_project, :a, key: &quot;value&quot; config :my_project, MyProject.B, key: &quot;value&quot; config :my_project, :b, key: &quot;value&quot; config :another_package, key: value config :package, key: &quot;value&quot;","ref":"Surgex.Guide.CodeStyle.html#config_order/0","title":"Surgex.Guide.CodeStyle.config_order/0","type":"function"},{"doc":"Documentation in @doc and @moduledoc should be written in ExDoc-friendly Markdown.Here's what is considered an ExDoc-friendly Markdown:Paragraphs written with full sentences, separated by a blank lineHeadings starting from 2nd level heading (## Biggest heading)Bullet lists starting with a dash and subsequent lines indented by 2 spacesBullet/ordered list items separated by a blank lineElixir code indented by 4 spaces to mark the code blockReasoningThis syntax is encouraged in popular Elixir libraries, it's confirmed to generate nicely readable output and it's just as readable in the code which embeds it as well.ExamplesPreferred:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; User account authorization and management system. This module does truly amazing stuff. It&#39;s purpose is to take anything you pass its way and make an user out of that. It can also tell you if specific user can do specific things without messing the system too much. Here&#39;s what you can expect from this module: - Nicely written lists with a lot of precious information that get indented properly in every subsequent line - And that are well padded as well And here&#39;s an Elixir code example: defmodule MyProject.Accounts.User do @defstruct [:name, :email] end It&#39;s all beautiful, isn&#39;t it? &quot;&quot;&quot; endMessed up line breaks, messed up list item indentation and non ExDoc-ish code block:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; User account authorization and management system. This module does truly amazing stuff. It&#39;s purpose is to take anything you pass its way and make an user out of that. It can also tell you if specific user can do specific things without messing the system too much. Here&#39;s what you can expect from this module: - Nicely written lists with a lot of precious information that get indented properly in every subsequent line - And that are well padded as well And here&#39;s an Elixir code example: ``` defmodule MyProject.Accounts.User do @defstruct [:name, :email] end ``` It&#39;s not so beautiful, is it? &quot;&quot;&quot; end","ref":"Surgex.Guide.CodeStyle.html#doc_content_format/0","title":"Surgex.Guide.CodeStyle.doc_content_format/0","type":"function"},{"doc":"There must be no blank lines between @doc and the function definition.ReasoningCompared to moduledoc spacing, the @doc clause belongs to the function definition directly beneath it, so the lack of blank line between the two is there to make this linkage obvious. If the blank line is there, there's a growing risk of @doc clause becoming completely separated from its owner in the heat of future battles.ExamplesPreferred:@doc &quot;&quot;&quot; This is by far the most complex function in the universe. &quot;&quot;&quot; def func, do: nilWeak linkage:@doc &quot;&quot;&quot; This is by far the most complex function in the universe. &quot;&quot;&quot; def func, do: nilBroken linkage:@doc &quot;&quot;&quot; This is by far the most complex function in the universe. &quot;&quot;&quot; def non_complex_func, do: something_less_complex_than_returning_nil() def func, do: nil","ref":"Surgex.Guide.CodeStyle.html#doc_spacing/0","title":"Surgex.Guide.CodeStyle.doc_spacing/0","type":"function"},{"doc":"Documentation in @doc and @moduledoc should start with an one-line summary sentence.ReasoningThis first line is treated specially by ExDoc in that it's taken as a module/function summary for API summary listings. The period at its end is removed so that it looks good both as a summary (without the period) and as part of a whole documentation (with a period).The single-line limit (with up to 100 characters as per line limit rule) is there to avoid mixing up short and very long summaries on a single listing.It's also important to fit as precise description as possible in this single line, without unnecessarily repeating what's already expressed in the module or function name itself.ExamplesPreferred:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; User account authorization and management system. &quot;&quot;&quot; endToo vague:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; Accounts system. &quot;&quot;&quot; endMissing trailing period:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; Accounts system &quot;&quot;&quot; endMissing trailing blank line:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; User account authorization and management system. All functions take the `MyProject.Accounts.Input` structure as input argument. &quot;&quot;&quot; end","ref":"Surgex.Guide.CodeStyle.html#doc_summary_format/0","title":"Surgex.Guide.CodeStyle.doc_summary_format/0","type":"function"},{"doc":"Keywords in Ecto queries should be indented by one level (and one more for on after join).ReasoningHorizontal alignment is something especially tempting in Elixir programming as there are many operators and structures that look cool when it gets applied. In particular, Ecto queries are often written (and they do look good) when aligned to : after from macro keywords. In order to achieve that, vertical alignment is often overused.The issue is with future-proofness of such alignment. For instance, it'll get ruined when longer keyword will have to be added, such as preload or select in queries with only join or where.It's totally possible to adhere to the 2 space indentation rule and yet to write a good looking and readable Ecto query. In order to make things more readable, additional 2 spaces can be added for contextual indentation of sub-keywords, like on after join.ExamplesPreferred:from users in User, join: credit_cards in assoc(users, :credit_card), on: is_nil(credit_cards.deleted_at), where: is_nil(users.deleted_at), select: users.id, preload: [:credit_card],Cool yet not so future-proof:from users in User, join: credit_cards in assoc(users, :credit_card), on: is_nil(credit_cards.deleted_at), where: is_nil(users.deleted_at)","ref":"Surgex.Guide.CodeStyle.html#ecto_query_indentation/0","title":"Surgex.Guide.CodeStyle.ecto_query_indentation/0","type":"function"},{"doc":"Exception modules (and only them) should be named with the Error suffix.ReasoningExceptions are a distinct kind of application entities, so it's good to emphasize that in their naming. Two most popular suffixes are Exception and Error. The latter was choosen for brevity.ExamplesPreferred:defmodule InvalidCredentialsError do defexception [:one, :other] endInvalid suffix:defmodule InvalidCredentialsException do defexception [:one, :other] endUsage of Error suffix for non-exception modules:defmodule Actions.HandleRegistrationError do # ... end","ref":"Surgex.Guide.CodeStyle.html#exception_naming/0","title":"Surgex.Guide.CodeStyle.exception_naming/0","type":"function"},{"doc":"Exceptions should define semantic struct fields and a custom message/1 function.ReasoningIt's possible to define an exception with custom arguments and message by overriding the exception/1 function and defining a standard defexception [:message] struct, but that yields to non-semantic exceptions that don't express their arguments in their structure. It also makes it harder (or at least inconsistent) to define multi-argument exceptions, which is simply a consequence of not having a struct defined for an actual struct.Therefore, it's better to define exceptions with a custom set of struct fields instead of a message field and to define a message/1 function that takes those fields and creates an error message out of them.ExamplesPreferred:defmodule MyError do defexception [:a, :b] def message(%__MODULE__{a: a, b: b}) do &quot;a: \#{a}, b: \#{b}&quot; end end raise MyError, a: 1, b: 2Non-semantic error struct with unnamed fields in multi-argument call:defmodule MyError do defexception [:message] def exception({a, b}) do %__MODULE__{message: &quot;a: \#{a}, b: \#{b}&quot;} end end raise MyError, {1, 2}","ref":"Surgex.Guide.CodeStyle.html#exception_structure/0","title":"Surgex.Guide.CodeStyle.exception_structure/0","type":"function"},{"doc":"Functions should be called with parentheses.ReasoningThere's a convention in Elixir universe to make function calls distinct from macro calls by consistently covering them with parentheses. Function calls often take part in multiple operations in a single line or inside pipes and as such, it's just safer to mark the precedence via parentheses.ExamplesPreferred:first() &amp;&amp; second(arg)Unreadable and with compiler warning coming up:first &amp;&amp; second arg","ref":"Surgex.Guide.CodeStyle.html#function_call_parentheses/0","title":"Surgex.Guide.CodeStyle.function_call_parentheses/0","type":"function"},{"doc":"Indentation must be done with 2 spaces.ReasoningThis is kind of a delicate subject, but seemingly both Elixir and Ruby communities usually go for spaces, so it's best to stay aligned.When it comes to linting, the use of specific number of spaces works well with the line length rule, while tabs can be expanded to arbitrary number of soft spaces in editor, possibly ruining all the hard work put into staying in line with the column limit.As to the number of spaces, 2 seems to be optimal to allow unconstrained module, function and block indentation without sacrificing too many columns.ExamplesPreferred:defmodule User do def blocked?(user) do !user.confirmed || user.blocked end endToo deep indentation (and usual outcome of using tabs):defmodule User do def blocked?(user) do !user.confirmed || user.blocked end endMissing single space:defmodule User do def blocked?(user) do !user.confirmed || user.blocked end end","ref":"Surgex.Guide.CodeStyle.html#indentation/0","title":"Surgex.Guide.CodeStyle.indentation/0","type":"function"},{"doc":"Inline blocks should be preferred for simple code that fits one line.ReasoningIn case of simple and small functions, conditions etc, the inline variant of block allows to keep code more compact and fit biggest piece of the story on the screen without losing readability.ExamplesPreferred:def add_two(number), do: number + 2Wasted vertical space:def add_two(number) do number + 2 endToo long (or too complex) to be inlined:def add_two_and_multiply_by_the_meaning_of_life_and_more(number), do: (number + 2) * 42 * get_more_for_this_truly_crazy_computation(number)","ref":"Surgex.Guide.CodeStyle.html#inline_block_usage/0","title":"Surgex.Guide.CodeStyle.inline_block_usage/0","type":"function"},{"doc":"Lines must not be longer than 100 characters.ReasoningThe old-school 70 or 80 column limits seem way limiting for Elixir which is highly based on indenting blocks. Considering modern screen resolutions, 100 columns should work well for anyone with something more modern than CGA video card.Also, 100 column limit plays well with GitHub, CodeClimate, HexDocs and others.ExamplesPreferred:defmodule MyProject.Accounts.User do def build(%{ &quot;first_name&quot; =&gt; first_name, &quot;last_name&quot; =&gt; last_name, &quot;email&quot; =&gt; email, &quot;phone_number&quot; =&gt; phone_number }) do %__MODULE__{ first_name: first_name, last_name: last_name, email: email, phone_number: phone_number } end endMissing line breaks before limit:defmodule MyProject.Accounts.User do def build(%{&quot;first_name&quot; =&gt; first_name, &quot;last_name&quot; =&gt; last_name, &quot;email&quot; =&gt; email, &quot;phone_number&quot; =&gt; phone_number}) do %__MODULE__{first_name: first_name, last_name: last_name, email: email, phone_number: phone_number} end end","ref":"Surgex.Guide.CodeStyle.html#line_length/0","title":"Surgex.Guide.CodeStyle.line_length/0","type":"function"},{"doc":"Hardcoded word (both string and atom) lists should be written using the ~w sigil.ReasoningThey're simply more compact and easier to read this way. They're also easier to extend. For long lists, line breaks can be applied without problems.ExamplesPreferred:~w(one two three) ~w(one two three)aHarder to read:[&quot;one&quot;, &quot;two&quot;, &quot;three&quot;] [:one, :two, :three]","ref":"Surgex.Guide.CodeStyle.html#list_format/0","title":"Surgex.Guide.CodeStyle.list_format/0","type":"function"},{"doc":"Macros should be called without parentheses.ReasoningThere's a convention in Elixir universe to make function calls distinct from macro calls by consistently covering them with parentheses. Compared to functions, macros are often used as a DSL, with one macro invocation per line. As such, they can be safely written (and just look better) without parentheses.ExamplesPreferred:if bool, do: nil from t in table, select: t.idMacro call that looks like a function call:from(t in table, select: t.id)","ref":"Surgex.Guide.CodeStyle.html#macro_call_parentheses/0","title":"Surgex.Guide.CodeStyle.macro_call_parentheses/0","type":"function"},{"doc":"Single blank line must be inserted after @moduledoc.Reasoning@moduledoc is a module-wide introduction to the module. It makes sense to give it padding and separate it from what's coming next. The reverse looks especially bad when followed by a function that has no @doc clause yet.ExamplesPreferred:defmodule SuperMod do @moduledoc &quot;&quot;&quot; This module is seriously amazing. &quot;&quot;&quot; def call, do: nil end@moduledoc that pretends to be a @doc:defmodule SuperMod do @moduledoc &quot;&quot;&quot; This module is seriously amazing. &quot;&quot;&quot; def call, do: nil end","ref":"Surgex.Guide.CodeStyle.html#moduledoc_spacing/0","title":"Surgex.Guide.CodeStyle.moduledoc_spacing/0","type":"function"},{"doc":"There must be no space put after the ! operator.ReasoningLike with brackets, it may be tempting to pad negation to make it more visible, but in general unary operators tend to be easier to parse when they live close to their argument. Why? Because they usually have precedence over binary operators and padding them away from their argument makes this precedence less apparent.ExamplesPreferred:!blocked &amp;&amp; allowedOperator precedence mixed up:! blocked &amp;&amp; allowed","ref":"Surgex.Guide.CodeStyle.html#negation_spacing/0","title":"Surgex.Guide.CodeStyle.negation_spacing/0","type":"function"},{"doc":"Large numbers must be padded with underscores.ReasoningThey're just more readable that way. It's one of those cases when a minimal effort can lead to eternal gratitude from other committers.ExamplesPreferred:x = 50_000_000&quot;How many zeros is that&quot; puzzle (hint: not as many as in previous example):x = 5000000","ref":"Surgex.Guide.CodeStyle.html#number_padding/0","title":"Surgex.Guide.CodeStyle.number_padding/0","type":"function"},{"doc":"Single space must be put around operators.ReasoningIt's a matter of keeping variable names readable and distinct in operator-intensive situations.There should be no technical problem with such formatting even in long lines, since those can be easily broken into multiple, properly indented lines.ExamplesPreferred:(a + b) / cHard to read:(a+b)/c","ref":"Surgex.Guide.CodeStyle.html#operator_spacing/0","title":"Surgex.Guide.CodeStyle.operator_spacing/0","type":"function"},{"doc":"Pipe chains must be aligned into multiple lines.Check out Surgex.Guide.CodeStyle.assignment_indentation/0 to see how to assign the output from properly formatted multi-line chains.ReasoningThis comes from general preference of vertical spacing over horizontal spacing, expressed across this guide by rules such as Surgex.Guide.CodeStyle.block_alignment/0. This ensures that the code is readable and not too condensed. Also, it's easier to modify or extend multi-line chains, because they don't require re-aligning the whole thing.By the way, single-line chains look kinda like a code copied from iex in a hurry, which is only fine when the building was on fire during the coding session.ExamplesPreferred:user |&gt; reset_password() |&gt; send_password_reset_email()Too condensed:user |&gt; reset_password() |&gt; send_password_reset_email()","ref":"Surgex.Guide.CodeStyle.html#pipe_chain_alignment/0","title":"Surgex.Guide.CodeStyle.pipe_chain_alignment/0","type":"function"},{"doc":"Pipe chains must be started with a plain value.ReasoningThe whole point of pipe chain is to push some value through the chain, end to end. In order to do that consistently, it's best to keep away from starting chains with function calls.This also makes it easier to see if pipe operator should be used at all - since chain with 2 pipes may get reduced to just 1 pipe when inproperly started with function call, it may falsely look like a case when pipe should not be used at all.ExamplesPreferred:arg |&gt; func() |&gt; other_func()Chain that lost its reason to live:func(arg) |&gt; other_func()","ref":"Surgex.Guide.CodeStyle.html#pipe_chain_start/0","title":"Surgex.Guide.CodeStyle.pipe_chain_start/0","type":"function"},{"doc":"Pipe chains must be used only for multiple function calls.ReasoningThe whole point of pipe chain is that... well, it must be a chain. As such, single function call does not qualify. Reversely, nesting multiple calls instead of piping them seriously limits the readability of the code.ExamplesPreferred for 2 and more function calls:arg |&gt; func() |&gt; other_func()Preferred for 1 function call:yet_another_func(a, b)Not preferred:other_func(func(arg)) a |&gt; yet_another_func(b)","ref":"Surgex.Guide.CodeStyle.html#pipe_chain_usage/0","title":"Surgex.Guide.CodeStyle.pipe_chain_usage/0","type":"function"},{"doc":"RESTful actions should be placed in I S N C E U D order in controllers and their tests.ReasoningIt's important to establish a consistent order to make it easier to find actions and their tests, considering that both controller and (especially) controller test files tend to be big at times.This particular order (index, show, new, create, edit, update, delete) comes from the long-standing convention established by both Phoenix and, earlier, Ruby on Rails generators, so it should be familiar, predictable and non-surprising to existing developers.ExamplesPreferred:defmodule MyProject.Web.UserController do use MyProject.Web, :controller def index(_conn, _params), do: raise(&quot;Not implemented&quot;) def show(_conn, _params), do: raise(&quot;Not implemented&quot;) def new(_conn, _params), do: raise(&quot;Not implemented&quot;) def create(_conn, _params), do: raise(&quot;Not implemented&quot;) def edit(_conn, _params), do: raise(&quot;Not implemented&quot;) def update(_conn, _params), do: raise(&quot;Not implemented&quot;) def delete(_conn, _params), do: raise(&quot;Not implemented&quot;) endDifferent (CRUD-like) order against the convention:defmodule MyProject.Web.UserController do use MyProject.Web, :controller def index(_conn, _params), do: raise(&quot;Not implemented&quot;) def new(_conn, _params), do: raise(&quot;Not implemented&quot;) def create(_conn, _params), do: raise(&quot;Not implemented&quot;) def show(_conn, _params), do: raise(&quot;Not implemented&quot;) def edit(_conn, _params), do: raise(&quot;Not implemented&quot;) def update(_conn, _params), do: raise(&quot;Not implemented&quot;) def delete(_conn, _params), do: raise(&quot;Not implemented&quot;) endThe issue with CRUD order is that index action falls between fitting and being kind of &quot;above&quot; the Read section and new/edit actions fall between Read and Create/Update sections, respectively.","ref":"Surgex.Guide.CodeStyle.html#restful_action_order/0","title":"Surgex.Guide.CodeStyle.restful_action_order/0","type":"function"},{"doc":"Reuse directives against same module should be grouped with {} syntax and sorted A-Z.ReasoningThe fresh new grouping feature for alias, import, require and use allows to make multiple reuses from single module shorter, more declarative and easier to comprehend. It's just a challenge to use this feature consistently, hence this rule.Keeping sub-module names in separate lines (even when they could fit a single line) is an additional investment for the future - to have clean diffs when more modules will get added. It's also easier to keep them in alphabetical order when they're in separate lines from day one.ExamplesPreferred:alias Toolbox.{ Creator, Deletor, Other, } alias SomeOther.ModShort but not so future-proof:alias Toolbox.{Creator, Deletor, Other}Classical but inconsistent and not so future-proof:alias Toolbox.Creator alias Toolbox.Deletor alias SomeOther.Mod alias Toolbox.Other","ref":"Surgex.Guide.CodeStyle.html#reuse_directive_grouping/0","title":"Surgex.Guide.CodeStyle.reuse_directive_grouping/0","type":"function"},{"doc":"Calls to reuse directives should be placed in use, require, import,alias order.ReasoningFirst of all, having any directive ordering convention definitely beats not having one, since they are a key to parsing code and so it adds up to better code reading experience when you know exactly where to look for an alias or import.This specific order is an attempt to introduce more significant directives before more trivial ones. It so happens that in case of reuse directives, the reverse alphabetical order does exactly that, starting with use (which can do virtually anything with a target module) and ending with alias (which is only a cosmetic change and doesn't affect the module's behavior).ExamplesPreferred:use Helpers.Thing import Helpers.Other alias Helpers.ToolOut of order:alias Helpers.Tool import Helpers.Other use Helpers.Thing","ref":"Surgex.Guide.CodeStyle.html#reuse_directive_order/0","title":"Surgex.Guide.CodeStyle.reuse_directive_order/0","type":"function"},{"doc":"Reuse directives should be placed on top of modules or functions.ReasoningCalls to alias, import, require or use should be placed on top of module or function, or directly below @moduledoc in case of modules with documentation.Just like with the order rule, this is to make finding these directives faster when reading the code. For that reason, it's more beneficial to have such important key for interpreting code in obvious place than attempting to have them right above the point where they're needed (which usually ends up messed up anyway when code gets changed over time).ExamplesPreferred:defmodule Users do alias Users.User def name(user) do user[&quot;name&quot;] || user.name end def delete(user_id) do import Ecto.Query user_id = String.to_integer(user_id) Repo.delete_all(from users in User, where: users.id == ^user_id) end endCool yet not so future-proof &quot;lazy&quot; placement:defmodule Users do def name(user) do user[&quot;name&quot;] || user.name end alias Users.User def delete(user_id) do user_id = String.to_integer(user_id) import Ecto.Query Repo.delete_all(from users in User, where: users.id == ^user_id) end end","ref":"Surgex.Guide.CodeStyle.html#reuse_directive_placement/0","title":"Surgex.Guide.CodeStyle.reuse_directive_placement/0","type":"function"},{"doc":"Per-function usage of reuse directives should be preferred over module-wide usage.ReasoningIf a need for alias, import or require spans only across single function in a module (or across a small subset of functions in otherwise large module), it should be preferred to declare it locally on top of that function instead of globally for whole module.Keeping these declarations local makes them even more descriptive as to what scope is really affected. They're also more visible, being closer to the place they're used at. The chance for conflicts is also reduced when they're local.ExamplesPreferred (alias on Users.User is used in both create and delete functions so it's made global, but import on Ecto.Query is only used in delete function so it's declared only there):defmodule Users do alias Users.User def create(params) %User{} |&gt; User.changeset(params) |&gt; Repo.insert() end def delete(user_id) do import Ecto.Query Repo.delete_all(from users in User, where: users.id == ^user_id) end endNot so DRY (still, this could be OK if there would be more functions in Users module that wouldn't use the User sub-module):defmodule Users do def create(params) alias Users.User %User{} |&gt; User.changeset(params) |&gt; Repo.insert() end def delete(user_id) do import Ecto.Query alias Users.User Repo.delete_all(from users in User, where: users.id == ^user_id) end endEverything a bit too public:defmodule Users do import Ecto.Query alias Users.User def create(params) %User{} |&gt; User.changeset(params) |&gt; Repo.insert() end def delete(user_id) do Repo.delete_all(from users in User, where: users.id == ^user_id) end end","ref":"Surgex.Guide.CodeStyle.html#reuse_directive_scope/0","title":"Surgex.Guide.CodeStyle.reuse_directive_scope/0","type":"function"},{"doc":"Calls to reuse directives should not be separated with blank lines.ReasoningIt may be tempting to separate all aliases from imports with blank line or to separate multi-line grouped aliases from other aliases, but as long as they're properly placed and ordered, they're readable enough without such extra efforts. Also, as their number grows, it's more beneficial to keep them vertically compact than needlessly padded.ExamplesPreferred:use Helpers.Thing import Helpers.Other alias Helpers.Subhelpers.{ First, Second } alias Helpers.ToolToo much padding (with actual code starting N screens below):use Helpers.Thing import Helpers.Other alias Helpers.Subhelpers.{ First, Second } alias Helpers.Tool","ref":"Surgex.Guide.CodeStyle.html#reuse_directive_spacing/0","title":"Surgex.Guide.CodeStyle.reuse_directive_spacing/0","type":"function"},{"doc":"; must not be used to separate statements and expressions.ReasoningThis is the most classical case when it comes to preference of vertical over horizontal alignment. Let's just keep ; operator for iex sessions and focus on code readability over doing code minification manually - neither EVM nor GitHub will explode over that additional line break.Actually, &quot;, &quot; costs one more byte than an Unix line break but if that would be our biggest concern then I suppose we wouldn't prefer spaces over tabs for indentation...ExamplesPreferred:func() other_func()iex session saved to file by mistake:func(); other_func()","ref":"Surgex.Guide.CodeStyle.html#semicolon_usage/0","title":"Surgex.Guide.CodeStyle.semicolon_usage/0","type":"function"},{"doc":"Basic happy case in a test file or scope should be placed on top of other cases.ReasoningWhen using tests to understand how specific unit of code works, it's very handy to have the basic happy case placed on top of other cases.ExamplesPreferred:defmodule MyProject.Web.MyControllerTest do describe &quot;index/2&quot; do test &quot;works for valid params&quot; do # ... end test &quot;fails for invalid params&quot; do # ... end end endOut of order:defmodule MyProject.Web.MyControllerTest do describe &quot;index/2&quot; do test &quot;fails for invalid params&quot; do # ... end test &quot;works for valid params&quot; do # ... end end end","ref":"Surgex.Guide.CodeStyle.html#test_happy_case_placement/0","title":"Surgex.Guide.CodeStyle.test_happy_case_placement/0","type":"function"},{"doc":"Files must end with single line break.ReasoningMany editors and version control systems consider files without final line break invalid. In git, such last line gets highlighted with an alarming red. Like with trailing white-space, it's a bad habit to leave such artifacts and ruin diffs for developers who save files correctly.Reversely, leaving too many line breaks is just sloppy.Most editors can be tuned to automatically add single trailing line break on save.ExamplesPreferred:func()⮐Missing line break:func()Too many line breaks:func()⮐ ⮐","ref":"Surgex.Guide.CodeStyle.html#trailing_newline/0","title":"Surgex.Guide.CodeStyle.trailing_newline/0","type":"function"},{"doc":"Lines must not end with trailing white-space.ReasoningLeaving white-space at the end of lines is a bad programming habit that leads to crazy diffs in version control once developers that do it get mixed with those that don't.Most editors can be tuned to automatically trim trailing white-space on save.ExamplesPreferred:func()Hidden white-space (simulated by adding comment at the end of line):func() # line end","ref":"Surgex.Guide.CodeStyle.html#trailing_whitespace/0","title":"Surgex.Guide.CodeStyle.trailing_whitespace/0","type":"function"},{"doc":"Modules referenced in typespecs should be aliased.ReasoningWhen writing typespecs, it is often necessary to reference a module in some nested naming scheme. One could reference it with the absolute name, e.g. Application.Accounting.Invoice.t, but this makes typespecs rather lengthy.Using aliased modules makes typespecs easier to read and, as an added benefit, it allows for an in-front declaration of module dependencies. This way we can easily spot breaches in module isolation.ExamplesPreferred:alias VideoApp.Recommendations.{Rating, Recommendation, User} @spec calculate_recommendations(User.t, [Rating.t]) :: [Recommendation.t] def calculate_recommendations(user, ratings) do # ... endWay too long:@spec calculate_recommendations( VideoApp.Recommendations.User.t, [VideoApp.Recommendations.Rating.t] ) :: [VideoApp.Recommendations.Recommendation.t] def calculate_recommendations(user, ratings) do # ... end","ref":"Surgex.Guide.CodeStyle.html#typespec_alias_usage/0","title":"Surgex.Guide.CodeStyle.typespec_alias_usage/0","type":"function"},{"doc":"Higher level application design and engineering guidelines.","ref":"Surgex.Guide.SoftwareDesign.html","title":"Surgex.Guide.SoftwareDesign","type":"module"},{"doc":"Errors should be thrown as close to the spot of failure and unhandled unless required.ReasoningThrowing an exception (or using a throwing equivalent of a standard library function) allows to avoid spending an additional time on inventing failure paths in the code and handling them higher in the call stack.It may be tempting to go with an error return value, such as the {:error, ...} tuple, in order to let the code higher in the call stack to decide what to do in a specific situation, but that only makes sense when it makes sense, ie. there exists a valid case higher in the call stack that would want to do something other than throwing or returning a meaningless, generic error.Otherwise, when a hard system-wide failure ends up not being an exception, it may look like a step towards reusability, but it's really anti-semantic and the specific code unit (function or module) stops telling the whole story, ie. multiple files must be read in order to come up with a simple conclusion that we really end up with an exception anyway.This may be extra important during a debugging session, since the closer an exception happens to the spot of failure, the easier it is for developer to understand the real reason behind it. For the same reason, it's always better to use a throwing equivalent of a standard library function (with the ! suffix) in places which don't handle the negative scenario anyway further down the pipe.ExamplesPreferred:def do_something_external(params) do required = Keyword.fetch!(params, :required) optional = Keyword.get(params, :optional) integer = params |&gt; Keyword.fetch!(:integer) |&gt; String.to_integer case external_api_call(required, optional, integer) do %{status: 200, body: body} -&gt; body[&quot;result&quot;] %{status: error_status, body: error_body} -&gt; raise(&quot;External API error \#{error_status}: \#{inspect error_body}&quot;) end endBad code (read the explanation below):def do_something_external(params) do required = Keyword.get(params, :required) optional = Keyword.get(params, :optional) {integer, _} = params |&gt; Keyword.fetch!(:integer) |&gt; Integer.parse case external_api_call(required, optional, integer) do %{status: 200, body: body} -&gt; {:ok, body[&quot;result&quot;]} _ -&gt; {:error, :external_api_failed} end endThere are following problems in the code above:not throwing on forgotten :required_option as early as possible will yield problems further down the pipe that will be hard to debug since debugging session will have to track the issue back to the original spot that we could've thrown at since the beginningnot using optimal standard library means for throwing a descriptive error for failed string to integer conversion (String.to_integer) will yield a less descriptive match error (and the match-all on a 2nd elem of tuple from Integer.parse may produce bugs)returning {:error, :external_api_failed} on failure from external API will force the caller of do_something_external to handle this case, so it makes sense only if we can actually do something that makes sense (other than raising, silencing the issue or making it ambiguous)","ref":"Surgex.Guide.SoftwareDesign.html#error_handling/0","title":"Surgex.Guide.SoftwareDesign.error_handling/0","type":"function"},{"doc":"Errors from external contexts should be mapped to have a meaning in the current context.ReasoningElixir allows to match and forward everything in case and with-else match clauses (which are often used to control the high level application flow) or to simply omit else for with. This often results in bubbling up errors, such as those in {:error, reason} tuples, to the next context in which those errors are ambiquous or not fitting the context into which they traverse. For instance, {:error, :forbidden} returned from a HTTP client is ambiguous and not fitting the context of a service or controller that calls it. The following questions are unanswered:what exactly is forbidden?why would I care if it's forbidden and not, for instance, temporarily unavailable?what actually went wrong?how does it map to actual input args?A reverse case is also possible when errors in lower contexts are intentionally named to match upper context expectations, breaking the separation of concerns. For instance, a service may return {:error, :not_found} or {:error, :forbidden} in order to implicitly fall into fallback controller's expectations, even though a more descriptive error naming could've been invented.Therefore, care should be put into naming errors in a way that matters in the contexts where they're born and into leveraging case and with-else constructs to re-map ambiguous or not fitting errors into a meaningful and fitting ones when they travel across context bounds.ExamplesPreferred:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} else {:error, changeset = %Ecto.Changeset{}} -&gt; {:error, :invalid_attributes, changeset} {:error, :not_available} -&gt; {:error, :mailing_service_not_available} end end endAmbiguous and &quot;out of context&quot; errors:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} else {:error, changeset = %Ecto.Changeset{}} -&gt; {:error, changeset} {:error, :not_available} -&gt; {:error, :not_available} end end end","ref":"Surgex.Guide.SoftwareDesign.html#error_mapping/0","title":"Surgex.Guide.SoftwareDesign.error_mapping/0","type":"function"},{"doc":"Flow control directives should be leveraged to yield compact and readable code.ReasoningEach of flow control directives (if, cond, case, with) has its own purpose, but sometimes more than one of them can be used to achieve the same goal. In such cases, the one that yields the most compact and readable code should be picked.ExamplesPreferred:with {:ok, user} &lt;- load_user(id), {:ok, avatar} &lt;- load_user_avatar(user) do {:ok, user, avatar} endRedundant case equivalent of the above:case load_user(id) do {:ok, user} -&gt; case load_user_avatar(user) do {:ok, avatar} -&gt; {:ok, user, avatar} error -&gt; error end error -&gt; error end","ref":"Surgex.Guide.SoftwareDesign.html#flow_directive_usage/0","title":"Surgex.Guide.SoftwareDesign.flow_directive_usage/0","type":"function"},{"doc":"Function clauses should be grouped together, ie. without a blank line between them.ReasoningThis allows to easily read a whole set of specific function's clauses and spot the start and end of the whole story of that specific function.ExamplesPreferred:def active?(%User{confirmed_at: nil}), do: false def active?(%User{}), do: true def deleted?(%User{deleted_at: nil}), do: false def deleted?(%User{}), do: trueNo obvious visual bounds for each function:def active?(%User{confirmed_at: nil}), do: false def active?(%User{}), do: true def deleted?(%User{deleted_at: nil}), do: false def deleted?(%User{}), do: true","ref":"Surgex.Guide.SoftwareDesign.html#function_clause_grouping/0","title":"Surgex.Guide.SoftwareDesign.function_clause_grouping/0","type":"function"},{"doc":"Functions should be grouped by their relationship rather than by &quot;public then private&quot;.ReasoningThe existence of a def + defp directive pair allows to leave behind the old habits for defining all the public functions before private ones. Keeping related functions next to each other allows to read the code faster and to easily get the grasp of the whole module flow.The best rule of thumb is to place every private function directly below first other function that calls it.ExamplesPreferred:def a, do: b() defp a_helper, do: nil def b, do: nil defp b_helper, do: nilHarder to read:def a, do: b() def b, do: nil defp a_helper, do: nil defp b_helper, do: nil","ref":"Surgex.Guide.SoftwareDesign.html#function_order/0","title":"Surgex.Guide.SoftwareDesign.function_order/0","type":"function"},{"doc":"Usage of import directive at module level or without the only option should be avoided.ReasoningWhen importing at module level, one adds a set of foreign functions to the module that may conflict with existing ones. This gets worse when multiple modules are imported and their names start to clash with each other. When project complexity increases over time and the preference for imports over aliases grows, the developer will sooner or later be forced to name functions in a custom to-be-imported module in a way that scopes them in a target module and/or avoids naming conflicts with other to-be-imported modules. This results in bad function naming - names start to be unnecessarily long or to repeat the module name in a function name.When importing without the only option, it's unclear without visiting the source of imported module what exact function names and arities come from the external place. This makes the code harder to reason about.ExamplesPreferred:defmodule User do def full_name(%{first_name: first_name, last_name: last_name}) do import Enum, only: [join: 2] join([first_name, last_name]) end endToo wide scope:defmodule User do import Enum, only: [join: 2] def full_name(%{first_name: first_name, last_name: last_name}) do join([first_name, last_name]) end endUnknown imports:defmodule User do def full_name(%{first_name: first_name, last_name: last_name}) do import Enum join([first_name, last_name]) end end","ref":"Surgex.Guide.SoftwareDesign.html#import_usage/0","title":"Surgex.Guide.SoftwareDesign.import_usage/0","type":"function"},{"doc":"Non-false moduledoc should be filled only for global, context-external app modules.ReasoningFilling moduledoc results in adding the module to module list in the documentation. Therefore, it makes little sense to use it only to leave a comment about internal mechanics of specific module or its meaning in the context of a closed application domain. For such cases, regular comments should be used. This will yield a clean documentation with eagle-eye overview of the system and its parts that can be directly used from global or external perspective.ExamplePreferred:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; Account management system. &quot;&quot;&quot; @doc &quot;&quot;&quot; Registers an user account. &quot;&quot;&quot; def register(attrs) do MyProject.Accounts.RegistrationService.call(attrs) end end defmodule MyProject.Accounts.RegistrationService do @moduledoc false # Fails on occasion due to Postgres connection issue. # Works best on Fridays. def call(attrs) do # ... end endUnnecessary external-ization and comment duplication:defmodule MyProject.Accounts do @moduledoc &quot;&quot;&quot; Account management system. &quot;&quot;&quot; @doc &quot;&quot;&quot; Registers an user account. &quot;&quot;&quot; def register(attrs) do MyProject.Accounts.RegistrationService.call(attrs) end end defmodule MyProject.Accounts.RegistrationService do @moduledoc &quot;&quot;&quot; Registers an user account. Fails on occasion due to Postgres connection issue. Works best on Fridays. &quot;&quot;&quot; def call(attrs) do # ... end end","ref":"Surgex.Guide.SoftwareDesign.html#moduledoc_usage/0","title":"Surgex.Guide.SoftwareDesign.moduledoc_usage/0","type":"function"},{"doc":"Kernel macros for working with nested structures should be preferred over manual assembly.This is about macros from the *_in family in the Elixir.Kernel module, like pop_in, put_in or update_in.ReasoningUsing these macros can vastly reduce the amount of code amd ensure that the complexity of digging and modifying nested structures is handled in the fastest way possible, as guaranteed by relying on a standard library. Implementing these flows manually leads to repetitive code and an open door for extra bugs.ExamplesPreferred:opts = [ user: [ name: &quot;John&quot;, email: &quot;user#xample.com&quot; ] ] opts_with_phone = put_in opts[:user][:phone], &quot;+48 600 700 800&quot;Unneeded complexity:opts = [ user: [ name: &quot;John&quot;, email: &quot;user#xample.com&quot; ] ] user_with_phone = Keyword.put(opts[:user], :phone, &quot;+48 600 700 800&quot;) opts_with_phone = Keyword.put(opts, :user, user_with_phone)","ref":"Surgex.Guide.SoftwareDesign.html#nested_struct_macro_usage/0","title":"Surgex.Guide.SoftwareDesign.nested_struct_macro_usage/0","type":"function"},{"doc":"Functions should not include more than one level of block nesting.ReasoningConstructs like with, case, cond, if or fn often need their own vertical space in order to make them readable, avoid cluttering and explicitly express dependencies needed by each block. Therefore, if they appear within each other, it should be preferred to extract the nested logic to separate function. This will often yield a good chance to replace some of these constructs with preferred solution of pattern matching function arguments.ExamplesPreferred:def calculate_total_cart_price(cart, items_key \\\\ :items, omit_below \\\\ 0) do reduce_cart_items_price(cart[items_key], omit_below) end defp sum_cart_items_price(nil, _omit_below), do: 0 defp sum_cart_items_price(items, omit_below) do Enum.reduce(items, 0, &amp;reduce_cart_item_price(&amp;1, &amp;2, omit_below)) end defp reduce_cart_item_price(%{price: price}, total, omit_below) when price &lt; omit_below do total end defp reduce_cart_item_price(%{price: price}, total, _omit_below) do total + price endCluttered and without obvious variable dependencies (items_key is not used in the deepest block while omit_below is):def calculate_total_cart_price(cart, items_key \\\\ :items, omit_below \\\\ 0) do if cart[items_key] do Enum.reduce(cart[items_key], 0, fn %{price: price}, total -&gt; if price &lt; omit_below do total else total + price end end) else 0 end end","ref":"Surgex.Guide.SoftwareDesign.html#nesting_depth/0","title":"Surgex.Guide.SoftwareDesign.nesting_depth/0","type":"function"},{"doc":"Keyword lists and tuples should be preferred over maps and lists for passing options.ReasoningKeyword lists and tuples are a standard, conventional means for passing internal information between Elixir modules.Keyword lists enforce a usage of atoms for keys and allow to pass single key more than once and in specific order when that's desired (and provide a merge function for when that's not desired). The price for last two feats is that they are not pattern-matchable (and should never be pattern matched) in cases when order and duplication is not important - functions from the Elixir.Keyword module should be used in those cases. Ot the other hand, pattern matching may come handy when parsing options with significant order of keys.Tuples declare a syntax for short, efficient, predefined lists and are useful in simpler and convention-driven cases, in which key naming is not needed. For instance, there's an established convention to return {:ok, result}/{:error, reason} tuples from actions that can succeed or fail without throwing.ExamplesPreferred:defp create_user(attrs, opts \\\\ []) do # required option auth_scope = Keyword.fetch!(opts, :send_welcome_email, false) # options with defaults send_welcome_email = Keyword.get(opts, :send_welcome_email, false) mark_as_confirmed = Keyword.get(opts, :mark_as_confirmed, true) case Repo.insert(%User{}, attrs) do {:ok, user} -&gt; final_user = user |&gt; send_email(send_welcome_email) |&gt; confirm(mark_as_confirmed) {:ok, final_user} {:error, changeset} -&gt; {:error, map_changeset_errors_to_error_reason(changeset.errors)} end endInvalid usage of maps over keyword lists:defp create_user(attrs, opts = %{}) do # ... endInvalid usage of lists over tuples:defp create_user(attrs) do # ... [:ok, user] end","ref":"Surgex.Guide.SoftwareDesign.html#option_format/0","title":"Surgex.Guide.SoftwareDesign.option_format/0","type":"function"},{"doc":"Pattern matching should be preferred over line-by-line destructuring of maps and structs.ReasoningPattern matching can be used to vastly simplify destructuring of complicated structures, so it should be used whenever possible, instead of taking out field by field via a struct getter (.) or an access operator ([]).It's supported in function clauses, so extensive use of the feature will also encourage writing more pattern-matched functions, which should in turn yield a code easier to parse for Elixir developers. Function headers with long matches can be easily broken into multiple lines and indented in a clean way, so the length of a match should not be the factor for making a decision about using or not using it.Even outside of function clauses, pattern matching is a blazing fast VM-supported feature that, combined with guards unwrapped at compilation time, should yield the best possible code performance.It's also worth mentioning that pattern matching can be also done inside of the assert macro in ExUnit in order to write selective, nicely diffed assertions on maps and structs.Pattern matching should not be preferred over functions from Keyword module for destructuring option lists, even if they can hold only one possible option at a time.ExamplesPreferred in function clauses:def create_user_from_json_api_document(%{ &quot;data&quot; =&gt; %{ &quot;id&quot; =&gt; id, &quot;attributes&quot; =&gt; %{ &quot;name&quot; =&gt; name, &quot;email&quot; =&gt; email, &quot;phone&quot; =&gt; phone } } }, mailing_enabled) do user = insert_user(id, name, email, phone) if mailing_enabled, do: send_welcome_email(user) endPreferred in tests:assert %User{ name: &quot;John&quot;, phone: &quot;+48 600 700 800&quot; } == CreateUserAction(name: &quot;John&quot;, email: email_sequence(), phone: &quot;+48 600 700 800&quot;)Cluttered:id = doc[&quot;data&quot;][&quot;id&quot;] name = doc[&quot;data&quot;][&quot;attributes&quot;][&quot;name&quot;] email = doc[&quot;data&quot;][&quot;attributes&quot;][&quot;email&quot;] phone = doc[&quot;data&quot;][&quot;attributes&quot;][&quot;phone&quot;]","ref":"Surgex.Guide.SoftwareDesign.html#pattern_matching_usage/0","title":"Surgex.Guide.SoftwareDesign.pattern_matching_usage/0","type":"function"},{"doc":"Predicate function names shouldn't start with is_ and should end with ?.ReasoningIt's an Elixir convention to name predicate functions with a ? suffix. It leverages the fact that this character can appear as function name suffix to make it easier to differentiate such functions from others.It's also an Elixir convention not to name predicate functions with a is_ prefix, since that prefix is reserved for guard-enabled predicate macros.Note that this rule doesn't apply to service functions that return success tuples instead of plain boolean values.ExamplesPreferred:def active?(user), do: trueFunction that pretends to be a guard:def is_active?(user), do: trueFunction that pretends not to be a predicate:def active(user), do: true","ref":"Surgex.Guide.SoftwareDesign.html#predicate_function_naming/0","title":"Surgex.Guide.SoftwareDesign.predicate_function_naming/0","type":"function"},{"doc":"Functions should return :ok/:error when both success and failure paths are present.ReasoningFirst of all, we do want to adhere to the long-standing Elixir convention of returning :ok/:error atoms from functions. They may either be stand-alone (simple :ok/:error when there's nothing more to add) or wrapped in a tuple with extra contextual info, such as {:ok, fetched_data} or {:error, reason}. Tuples may be mixed with stand-alone atoms, eg. the same function may return :ok upon success (since there's nothing more to add upon success) while multiple distinct error paths may return {:error, reason} to make them distinct to the caller.That said, there's a case when usage of this pattern may make the code more confusing. It's when specific code simply cannot fail. If it cannot fail, then it doesn't make sense to make it tell its caller that something went ok. In such cases, the function should simply return the value that was asked for (fetched_data in example above) or nil if there's nothing to return (eg. when a non-failing function only creates side effects).This fits nicely into the way the Elixir standard library is designed (eg. Map.get/2 never fails so it only returns the value but Map.fetch/2 does fail so it returns {:ok, value} or :error). As such, this rule makes our code consistent with Elixir conventions and community code that's supposed to follow them.Refer to the Surgex.Guide.SoftwareDesign.error_handling/0 rule in order to learn when to actually implement the failure path.ExamplesPreferred:def print_debug_info(message) do IO.puts(message) nil end def remove_file(path) do if File.exists?(path) :ok = File.rm(path) else {:error, :file_not_found} end endConfusing :ok when there's no failure path (IO.puts/1 returns :ok):def print_debug_info(message) do IO.puts(message) end def remove_file(path) do if File.exists?(path) :ok = File.rm(path) else raise(&quot;No such file: \#{inspect path}&quot;) end endLack of :ok when there's a failure path (File.read!/1 returns the file content):def read_file(path) do if File.exists?(path) File.read!(path) else {:error, :file_not_found} end end","ref":"Surgex.Guide.SoftwareDesign.html#return_ok_error_usage/0","title":"Surgex.Guide.SoftwareDesign.return_ok_error_usage/0","type":"function"},{"doc":"Sequential variable names, like user1, should respect underscore naming (and be avoided).ReasoningSequential variable names should be picked only as a last resort, since they're hard to express in underscore notation and are non-descriptive. For instance, in comparison function compare(integer_1, integer_2) can be replaced with compare(integer, other_integer).Sequence number added as suffix without the underscore is a breakage of underscore naming and looks especially bad when the name consists of more than one word, like user_location1.ExamplesPreferred:def compare(integer, other_integer), do: # ...Preferred as last resort:def add_three_nums(integer_1, integer_2, integer_3), do: # ...Plain ugly:def concat(file_name1, file_name2), do: # ...","ref":"Surgex.Guide.SoftwareDesign.html#sequential_variable_naming/0","title":"Surgex.Guide.SoftwareDesign.sequential_variable_naming/0","type":"function"},{"doc":"Tests should only use support test case modules that they need.ReasoningIf specific test only unit tests a module without using a web request, it shouldn't use ConnCase and if it doesn't create records, it shouldn't use DataCase. For many tests, ExUnit.Case will be enough of a support.This yields more semantic test headers and avoids needlessly importing and abusing of more complex support files.ExamplesPreferred:defmodule MyProject.Web.MyControllerTest do use MyProject.Web.ConnCase end defmodule MyProject.MyServiceTest do use MyProject.DataCase end defmodule NeitherControllerNorDatabaseTest do use ExUnit.Case endTest support file abuse:defmodule MyProject.MyServiceTest do use MyProject.Web.ConnCase end defmodule NeitherControllerNorDatabaseTest do use MyProject.DataCase end","ref":"Surgex.Guide.SoftwareDesign.html#test_case_usage/0","title":"Surgex.Guide.SoftwareDesign.test_case_usage/0","type":"function"},{"doc":"The unless directive should never be used with an else block or with logical operators.ReasoningThe unless directive is confusing and hard to reason about when used with more complex conditions or an alternative code path (which could be read as &quot;unless unless&quot;). Therefore, in such cases it should be rewritten as an if.ExamplesPreferred:unless user.confirmed, do: raise(&quot;user is not confirmed&quot;) if user.banned and not(user.vip) do raise(&quot;user is banned&quot;) else confirm_action(user) endToo hard to read:unless not(user.banned) or user.vip do confirm_action(user) else raise(&quot;user is banned&quot;) end","ref":"Surgex.Guide.SoftwareDesign.html#unless_usage/0","title":"Surgex.Guide.SoftwareDesign.unless_usage/0","type":"function"},{"doc":"Matches in a with-else block should be placed in occurrence order.ReasoningDoing this will make it much easier to reason about the whole flow of the with block, which tends to be quite complex and a core of flow control.ExamplesPreferred:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} else {:error, changeset = %Ecto.Changeset{}} -&gt; {:error, changeset} {:error, :not_available} -&gt; {:error, :not_available} end end endUnclear flow:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} else {:error, :not_available} -&gt; {:error, :not_available} {:error, changeset = %Ecto.Changeset{}} -&gt; {:error, changeset} end end end","ref":"Surgex.Guide.SoftwareDesign.html#with_else_order/0","title":"Surgex.Guide.SoftwareDesign.with_else_order/0","type":"function"},{"doc":"Redundant else block should not be provided for the with directive.ReasoningIn cases when all the code called in with resides in the same file (or in a standard library) and when none of else clauses would override the negative path's output, it's more semantic and descriptive to simply drop the else entirely. It's worth noting that else blocks in with bring an additional maintenance cost so it should be excused by either of conditions mentioned above.ExamplesPreferred:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- insert_user(attrs), :ok &lt;- send_welcome_email(user) do {:ok, user} end end defp insert_user(attrs), do: # ... defp send_welcome_email(user), do: # ... endRedundant and hard to maintain else:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- insert_user(attrs), :ok &lt;- send_welcome_email(user) do {:ok, user} else {:error, :insertion_error_a} -&gt; {:error, :insertion_error_a} {:error, :insertion_error_b} -&gt; {:error, :insertion_error_b} {:error, :insertion_error_c} -&gt; {:error, :insertion_error_c} {:error, :mailing_service_error_a} -&gt; {:error, :mailing_service_error_a} {:error, :mailing_service_error_b} -&gt; {:error, :mailing_service_error_b} {:error, :mailing_service_error_c} -&gt; {:error, :mailing_service_error_c} end end defp insert_user(attrs), do: # ... defp send_welcome_email(user), do: # ... end","ref":"Surgex.Guide.SoftwareDesign.html#with_else_redundancy/0","title":"Surgex.Guide.SoftwareDesign.with_else_redundancy/0","type":"function"},{"doc":"An else block should be provided for with when it forwards cases from external files.ReasoningThe with clause allows to omit else entirely if its only purpose is to amend the specific series of matches filled between with and do. In such cases, all non-matching outputs are forwarded (or &quot;bubbled up&quot;) by with. This is a cool feature that allows to reduce the amount of redundant negative matches when there's no need to amend them.It may however become a readability and maintenance problem when with calls to complex, external code from separate files, which makes it hard to reason about the complete set of possible outcomes of the whole with block. Therefore, it's encouraged to provide an else which lists a complete set of possible negative scenarios, even if they are not mapped to a different output.ExamplesPreferred:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} else {:error, changeset = %Ecto.Changeset{}} -&gt; {:error, changeset} {:error, :not_available} -&gt; {:error, :not_available} end end endUnclear cross-module flow:defmodule RegistrationService do def call(attrs) do with {:ok, user} &lt;- CreateUserFromAttributesService.call(attrs), :ok &lt;- SendUserWelcomeEmailService.call(user) do {:ok, user} end end end","ref":"Surgex.Guide.SoftwareDesign.html#with_else_usage/0","title":"Surgex.Guide.SoftwareDesign.with_else_usage/0","type":"function"},{"doc":"Parses, casts and catches errors in the web request input, such as params or JSON API body.UsageIn order to use it, you should import the Surgex.Parser module, possibly in the controller macro in the web.ex file belonging to your Phoenix project, which will make functions like parse available in all controllers.Then, you should start implementing functions for parsing params or documents for specific controller actions. Those functions will serve as documentation crucial for understanding specific action's input, so it's best to keep them close to the relevant action. For example:def index(conn, params) do with {:ok, opts} &lt;- parse_index_params(params) do render(conn, locations: Marketplace.search_locations(opts)) else {:error, :invalid_parameters, params} -&gt; {:error, :invalid_parameters, params} end end defp parse_index_params(params) do parse params, query: [:string, :required], center: :geolocation, box: :box, category_id: :id, subcategory_ids: :id_list, sort: {:sort, ~w{price_min published_at distance}a}, page: :page endThe second argument to parse/2 and flat_parse/2 is a param spec in which keys are resulting option names and values are parser functions, atoms, tuples or lists used to process specific parameter. Here's how each work:parser functions are functions that take the input value as first argument and can take arbitrary amount of additional arguments as parser options; in order to pass such parser it's best to use the &amp; operator in format &amp;parser/1 or in case of parser options &amp;parser(&amp;1, opts...)parser atoms point to built-in parsers by looking up a Surgex.Parser.&lt;camelized-name&gt;Parser module and invoking the call function within it, where the call function is just a parser function described above; for example :integer is an equivalent to &amp;Surgex.Parser.IntegerParser.call/1parser tuples allow to pass additional options to built-in parsers; the tuple starts with the parser atom described above, followed by parser arguments matching the number of additional arguments consumed by the parser; for example {:sort, ~w{price_min published_at}a}parser lists allow to pass a list of parser functions, atoms or tuples, all of which will be parsed in a sequence in which the output from previous parser is piped to the next one and in which the first failure stops the whole pipe; for example [:integer, :required]","ref":"Surgex.Parser.html","title":"Surgex.Parser","type":"module"},{"doc":"Makes sure there are no unknown params passed to controller action.","ref":"Surgex.Parser.html#assert_blank_params/1","title":"Surgex.Parser.assert_blank_params/1","type":"function"},{"doc":"Parses controller action input into a flat structure.This function takes the same input as parse/2 but it returns a {:ok, value1, value2, ...} tuple instead of a [key1: value1, key2: value2, ...] keyword list.","ref":"Surgex.Parser.html#flat_parse/2","title":"Surgex.Parser.flat_parse/2","type":"function"},{"doc":"Renames keys in the parser output.","ref":"Surgex.Parser.html#map_parsed_options/2","title":"Surgex.Parser.map_parsed_options/2","type":"function"},{"doc":"Parses controller action input (parameters, documents) with a given set of parsers.Returns a keyword list with parsed options.","ref":"Surgex.Parser.html#parse/2","title":"Surgex.Parser.parse/2","type":"function"},{"doc":"Parses controller action input (parameters, documents) with a given set of parsers.Returns a map with parsed options.","ref":"Surgex.Parser.html#parse_map/2","title":"Surgex.Parser.parse_map/2","type":"function"},{"doc":"Checks if the given parameter's value is on the list of allowed values.","ref":"Surgex.Parser.ContainParser.html","title":"Surgex.Parser.ContainParser","type":"module"},{"doc":"Return default value for an empty input.","ref":"Surgex.Parser.DefaultParser.html","title":"Surgex.Parser.DefaultParser","type":"module"},{"doc":"","ref":"Surgex.Parser.DefaultParser.html#call/3","title":"Surgex.Parser.DefaultParser.call/3","type":"function"},{"doc":"Holds a box made of two points on Earth's surface.","ref":"Surgex.Parser.Geobox.html","title":"Surgex.Parser.Geobox","type":"module"},{"doc":"","ref":"Surgex.Parser.Geobox.html#t:t/0","title":"Surgex.Parser.Geobox.t/0","type":"type"},{"doc":"Holds a specific point on Earth's surface.","ref":"Surgex.Parser.Geolocation.html","title":"Surgex.Parser.Geolocation","type":"module"},{"doc":"","ref":"Surgex.Parser.Geolocation.html#t:t/0","title":"Surgex.Parser.Geolocation.t/0","type":"type"},{"doc":"Parses the JSON API's include parameter according to the JSON API spec.Produces a list of includes constrained to the provided relationship paths.","ref":"Surgex.Parser.IncludeParser.html","title":"Surgex.Parser.IncludeParser","type":"module"},{"doc":"Flattens the result of the parser (inclusion list) into multiple keys.Examplesiex&gt; IncludeParser.flatten({:ok, include: [:user]}, :include) {:ok, include_user: true}","ref":"Surgex.Parser.IncludeParser.html#flatten/2","title":"Surgex.Parser.IncludeParser.flatten/2","type":"function"},{"doc":"","ref":"Surgex.Parser.IncludeParser.html#t:errors/0","title":"Surgex.Parser.IncludeParser.errors/0","type":"type"},{"doc":"","ref":"Surgex.Parser.IncludeParser.html#t:path/0","title":"Surgex.Parser.IncludeParser.path/0","type":"type"},{"doc":"Parses the JSON API's sort parameter according to the JSON API spec.Produces a {direction, column} tuple, in which direction is either :asc or :desc and column is a safely atomized and underscored column name.","ref":"Surgex.Parser.SortParser.html","title":"Surgex.Parser.SortParser","type":"module"},{"doc":"Flattens the result of the parser (sort tuple) into *_by and *_direction keys.Examplesiex&gt; SortParser.flatten({:ok, sort: {:asc, :col}}, :sort) {:ok, sort_by: :col, sort_direction: :asc}","ref":"Surgex.Parser.SortParser.html#flatten/2","title":"Surgex.Parser.SortParser.flatten/2","type":"function"},{"doc":"Available options:trim is trimming whitespaces from the string, takes priority over min and max optionsmin is a minimal length of the string, returns :too_short error symbolmax is a maximal length of the string, returns :too_long error symbolregex - input string must match passed regular expression, this is done after trimming","ref":"Surgex.Parser.StringParser.html","title":"Surgex.Parser.StringParser","type":"module"},{"doc":"","ref":"Surgex.Parser.StringParser.html#call/2","title":"Surgex.Parser.StringParser.call/2","type":"function"},{"doc":"","ref":"Surgex.Parser.StringParser.html#check_regex/1","title":"Surgex.Parser.StringParser.check_regex/1","type":"function"},{"doc":"","ref":"Surgex.Parser.StringParser.html#trim/1","title":"Surgex.Parser.StringParser.trim/1","type":"function"},{"doc":"","ref":"Surgex.Parser.StringParser.html#validate_max/1","title":"Surgex.Parser.StringParser.validate_max/1","type":"function"},{"doc":"","ref":"Surgex.Parser.StringParser.html#validate_min/1","title":"Surgex.Parser.StringParser.validate_min/1","type":"function"},{"doc":"","ref":"Surgex.Parser.StringParser.html#t:errors/0","title":"Surgex.Parser.StringParser.errors/0","type":"type"},{"doc":"","ref":"Surgex.Parser.StringParser.html#t:option/0","title":"Surgex.Parser.StringParser.option/0","type":"type"},{"doc":"This parser checks if the input is a proper UUID (with hyphens, case insentitive)","ref":"Surgex.Parser.UuidParser.html","title":"Surgex.Parser.UuidParser","type":"module"},{"doc":"","ref":"Surgex.Parser.UuidParser.html#call/1","title":"Surgex.Parser.UuidParser.call/1","type":"function"},{"doc":"Tools for making code maintenance and refactors easier.","ref":"Surgex.Refactor.html","title":"Surgex.Refactor","type":"module"},{"doc":"","ref":"Surgex.Refactor.html#call/1","title":"Surgex.Refactor.call/1","type":"function"},{"doc":"Maps module names to filenames and finds non-matches.","ref":"Surgex.Refactor.MapFilenames.html","title":"Surgex.Refactor.MapFilenames","type":"module"},{"doc":"","ref":"Surgex.Refactor.MapFilenames.html#call/2","title":"Surgex.Refactor.MapFilenames.call/2","type":"function"},{"doc":"","ref":"Surgex.Refactor.MapFilenames.html#fix/1","title":"Surgex.Refactor.MapFilenames.fix/1","type":"function"},{"doc":"","ref":"Surgex.Refactor.MapFilenames.html#scan/1","title":"Surgex.Refactor.MapFilenames.scan/1","type":"function"},{"doc":"Tools for dynamic setup of Ecto repo opts.NOTE: Deprecated in favor of Elixir 1.9 runtime configuration.","ref":"Surgex.RepoHelpers.html","title":"Surgex.RepoHelpers","type":"module"},{"doc":"Sets application_name to the value of APP_NAME env var.","ref":"Surgex.RepoHelpers.html#set_application_name/1","title":"Surgex.RepoHelpers.set_application_name/1","type":"function"},{"doc":"Sets repo options from env vars starting with specified prefix.Examplesiex&gt; System.put_env(&quot;DATABASE_URL&quot;, &quot;postgres://localhost&quot;) iex&gt; System.put_env(&quot;DATABASE_SERVER_POOL_SIZE&quot;, &quot;30&quot;) iex&gt; System.put_env(&quot;DATABASE_SSL&quot;, &quot;true&quot;) iex&gt; Application.put_env(:phoenix, :serve_endpoints, true) iex&gt; iex&gt; final_opts = Surgex.RepoHelpers.set_opts([]) iex&gt; iex&gt; Keyword.get(final_opts, :url) &quot;postgres://localhost&quot; iex&gt; Keyword.get(final_opts, :pool_size) 30 iex&gt; Keyword.get(final_opts, :ssl) true","ref":"Surgex.RepoHelpers.html#set_opts/2","title":"Surgex.RepoHelpers.set_opts/2","type":"function"},{"doc":"Sets repo database pool size from specified env var.","ref":"Surgex.RepoHelpers.html#set_pool_size/2","title":"Surgex.RepoHelpers.set_pool_size/2","type":"function"},{"doc":"Sets repo database pool size from specified env var only if Phoenix server is configured to run.","ref":"Surgex.RepoHelpers.html#set_server_pool_size/2","title":"Surgex.RepoHelpers.set_server_pool_size/2","type":"function"},{"doc":"Sets repo database ssl enable from specified env var.","ref":"Surgex.RepoHelpers.html#set_ssl/2","title":"Surgex.RepoHelpers.set_ssl/2","type":"function"},{"doc":"Sets repo database URL from specified env var.","ref":"Surgex.RepoHelpers.html#set_url/2","title":"Surgex.RepoHelpers.set_url/2","type":"function"},{"doc":"Extensions to the official Sentry package.NOTE: Deprecated in favor of Elixir 1.9 runtime configuration.","ref":"Surgex.Sentry.html","title":"Surgex.Sentry","type":"module"},{"doc":"Patches Sentry environment name and release version from env vars.By default, Sentry package only allows to fetch DSN from env var. This function extends that with environment name and release version set on runtime, thus enabling deployments on Heroku where application slug is compiled without final env vars.ExamplesIn order to execute this extension on application start, set an appropriate config key:config :surgex, sentry_patch_enabled: true","ref":"Surgex.Sentry.html#init/0","title":"Surgex.Sentry.init/0","type":"function"},{"doc":"Deeply scrubs params, obfuscating those with blacklisted names.By default, Sentry package only offers flat scrubbing of params. This won't work with nested params or JSON objects, so here's deep recursive equivalent of such scrubber.ExamplesIn order to use this extension, pass Surgex.Sentry.scrub_params/1 to Sentry.Plug like this:use Sentry.Plug, body_scrubber: &amp;Surgex.Sentry.scrub_params/1","ref":"Surgex.Sentry.html#scrub_params/1","title":"Surgex.Sentry.scrub_params/1","type":"function"},{"doc":"Surgex All Things Elixir @ Surge Ventures Inc, the creators of FreshaThis is the official entry point and hub for all company-wide Elixir efforts at Surge Ventures. Here's what you can expect to find in the Surgex repository.","ref":"readme.html","title":"Surgex","type":"extras"},{"doc":"Official style guide for Elixir and Phoenix projects at Surge Ventures, written in ExDoc format as a set of functions in the Surgex.Guide module (visit at HexDocs).","ref":"readme.html#elixir-knowledge-base","title":"Surgex - Elixir knowledge base","type":"extras"},{"doc":"Surgex is a package of cross-project helper modules, each too small or too young to justify publishing them separately. It currently consists of:Surgex.Changeset: tools for working with Ecto changesetsSurgex.DatabaseCleaner: cleans tables in a database represented by an Ecto repoSurgex.DataPipe: tools for moving data between PostgreSQL databases and tablesSurgex.Parser: parses, casts and catches errors in the web request inputSurgex.Refactor: tools for making code maintenance and refactors easierSurgex.Sentry: extensions to the official Sentry packageSurgex.RepoHelpers: tools for dynamic setup of Ecto repo opts","ref":"readme.html#surgex-bundle","title":"Surgex - Surgex bundle","type":"extras"},{"doc":"Besides the toolbelt bundle inside the Surgex package, we also maintain separate Elixir packages that contain our bigger and more serious open source efforts. Currently, we own the following repos:Jabbax - JSON API Building Blocks Assembly for Elixir","ref":"readme.html#separate-packages","title":"Surgex - Separate packages","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"New parser (Surgex.Parser.DefaultParser) returning default values","ref":"changelog.html#4-12-0-2022-09-05","title":"Changelog - 4.12.0 - 2022-09-05","type":"extras"},{"doc":"Added ability to return map with Surgex.Parser.parse_map/2 function","ref":"changelog.html#4-11-0","title":"Changelog - 4.11.0","type":"extras"},{"doc":"Extended compatibility with Jabbax to 1.0","ref":"changelog.html#4-10-0","title":"Changelog - 4.10.0","type":"extras"},{"doc":"New :regex option for Surgex.Parser.StringParser, allowing checking input agains given patternNew UUID parser (Surgex.Parser.UuidParser)Add support for :min, :max and :trim option for Surgex.Parser.EmailParser","ref":"changelog.html#4-9-0","title":"Changelog - 4.9.0","type":"extras"},{"doc":"New Surgex.DateTime module with date_and_offset_to_datetime/3 helper for creating UTC or time-zone date time","ref":"changelog.html#4-8-0","title":"Changelog - 4.8.0","type":"extras"},{"doc":"The Surgex.Parser.RequiredParser accepts an empty string as valid input","ref":"changelog.html#4-7-0","title":"Changelog - 4.7.0","type":"extras"},{"doc":"Parsers can now process any value without throwing exception on unknown value type","ref":"changelog.html#4-6-1","title":"Changelog - 4.6.1","type":"extras"},{"doc":"Updated Surgex.Parser.ResourceArrayParser to support invalid parameters","ref":"changelog.html#4-6-0","title":"Changelog - 4.6.0","type":"extras"},{"doc":"Extended parsers to match empty string values as nil","ref":"changelog.html#4-5-0","title":"Changelog - 4.5.0","type":"extras"},{"doc":"Extended parsing of ResourceID (&quot;&quot; -&gt; required)","ref":"changelog.html#4-4-0","title":"Changelog - 4.4.0","type":"extras"},{"doc":"Bump minor version","ref":"changelog.html#4-3-0","title":"Changelog - 4.3.0","type":"extras"},{"doc":"Extended parsing of boolean (&quot;true&quot; -&gt; true, &quot;false&quot; -&gt; false) and integers (&quot;&quot; -&gt; nil) values","ref":"changelog.html#4-2-1","title":"Changelog - 4.2.1","type":"extras"},{"doc":"Added support for translating errors in nested changeset to JSON API responses","ref":"changelog.html#4-2-0","title":"Changelog - 4.2.0","type":"extras"},{"doc":"Removed support for AppSignal","ref":"changelog.html#4-0-0","title":"Changelog - [4.0.0]","type":"extras"},{"doc":"Surgex.RepoHelpers sets ecto application_name based on APP_NAME env var","ref":"changelog.html#3-2-8","title":"Changelog - [3.2.8]","type":"extras"},{"doc":"Simplified email regex to fix catastrophic backtracing error when providing longer addresses","ref":"changelog.html#3-2-7","title":"Changelog - 3.2.7","type":"extras"},{"doc":"Added ssl in Surgex.RepoHelpers","ref":"changelog.html#3-2-6","title":"Changelog - 3.2.6","type":"extras"},{"doc":"Fixed typespec error in Surgex.Parser.BooleanParserAdded dialyzer --halt-exit-status to mix check","ref":"changelog.html#3-2-5","title":"Changelog - 3.2.5","type":"extras"},{"doc":"Added typespecs in Surgex.ParserDeprecated Surgex.Guide, Surgex.RepoHelpers and Surgex.Sentry","ref":"changelog.html#3-2-4","title":"Changelog - 3.2.4","type":"extras"},{"doc":"Improved Surgex.DataPipe.ForeignDataWrapper to alter pg server if it already exists","ref":"changelog.html#3-2-3","title":"Changelog - 3.2.3","type":"extras"},{"doc":"Fixed error in Surgex.Appsignal.EctoLogger for when event is missing stage times","ref":"changelog.html#3-2-2","title":"Changelog - 3.2.2","type":"extras"},{"doc":"Fixed compilation of Surgex.Appsignal.EctoLoggerAdded :all value for :query_stages option in Surgex.Appsignal.EctoLogger.handle_event/4","ref":"changelog.html#3-2-1","title":"Changelog - 3.2.1","type":"extras"},{"doc":"Added Surgex.Appsignal.EctoLogger","ref":"changelog.html#3-2-0","title":"Changelog - 3.2.0","type":"extras"},{"doc":"Added Surgex.RepoHelpers.set_pool_size/2 and included it in set_opts/2","ref":"changelog.html#3-1-0","title":"Changelog - 3.1.0","type":"extras"},{"doc":"Extended Surgex.Parser.IdListParser with support for list typeRemoved Surgex.ConfigRemoved Surgex.DeviseSessionRemoved Surgex.PhoneNumberRemoved Surgex.RPCRemoved Surgex.ScoutUpdated some deps","ref":"changelog.html#3-0-0","title":"Changelog - 3.0.0","type":"extras"},{"doc":"Added Surgex.RepoHelpers","ref":"changelog.html#2-24-1","title":"Changelog - 2.24.1","type":"extras"},{"doc":"Added Surgex.DataPipe.PostgresSystemUtilsFixed Surgex.DataPipe to support PostgreSQL 10Reformatted code with Elixir FormatterDeprecated Surgex.{Config, DeviseSession, PhoneNumber, RPC, Scout} modules","ref":"changelog.html#2-23-0","title":"Changelog - 2.23.0","type":"extras"},{"doc":"Extended Surgex.Parser.StringParser with trim, min and max optionsExtended Surgex.Parser.ResourceArrayParser with min and max optionsExtended Surgex.Parser.IncludeParser with support for multiple includes","ref":"changelog.html#2-22-0","title":"Changelog - 2.22.0","type":"extras"},{"doc":"Extended Surgex.DataPipe.RepoProxy with registry and follower sync","ref":"changelog.html#2-21-0","title":"Changelog - 2.21.0","type":"extras"},{"doc":"Fixed LSN check in Surgex.DataPipe.FollowerSync","ref":"changelog.html#2-20-1","title":"Changelog - 2.20.1","type":"extras"},{"doc":"Refine error handling in Surgex.DataPipe.FollowerSync","ref":"changelog.html#2-20-0","title":"Changelog - 2.20.0","type":"extras"},{"doc":"Added Surgex.DataPipe.RepoProxy","ref":"changelog.html#2-19-0","title":"Changelog - 2.19.0","type":"extras"},{"doc":"Added Surgex.Parser.ListParser","ref":"changelog.html#2-18-0","title":"Changelog - 2.18.0","type":"extras"},{"doc":"Extended Surgex.DataPipe.TableSync with delete_scope optionFixed Surgex.DataPipe.TableSync to properly use Ecto's query params","ref":"changelog.html#2-17-0","title":"Changelog - 2.17.0","type":"extras"},{"doc":"Extended Surgex.Parser.FloatParser with support for integers as input","ref":"changelog.html#2-16-0","title":"Changelog - 2.16.0","type":"extras"},{"doc":"Extended Surgex.Parser.FloatParser with support for floats as inputExtended Surgex.Parser.BooleanParser with support for booleans as input","ref":"changelog.html#2-15-0","title":"Changelog - 2.15.0","type":"extras"},{"doc":"Extended Surgex.Parser.FloatParser with min and max options","ref":"changelog.html#2-14-0","title":"Changelog - 2.14.0","type":"extras"},{"doc":"Added Surgex.Parser.ResourceParser","ref":"changelog.html#2-13-0","title":"Changelog - 2.13.0","type":"extras"},{"doc":"Fixed Surgex.RPC.Client to support no services in the clientRefactored Surgex.RPC for proper payload - transport separation","ref":"changelog.html#2-12-1","title":"Changelog - 2.12.1","type":"extras"},{"doc":"Added Surgex.Parser.SlugParserAdded Surgex.Parser.SlugOrIdParser","ref":"changelog.html#2-12-0","title":"Changelog - 2.12.0","type":"extras"},{"doc":"Added support for configuring Surgex.RPC.HTTPAdapter via Mix config, powered by Surgex.ConfigAdded support for passing service name atom to Surgex.RPC.Client.proto/1Added support for passing arbitrary opts to Protobuf via Surgex.RPC.Client.service/1","ref":"changelog.html#2-11-0","title":"Changelog - 2.11.0","type":"extras"},{"doc":"Added Surgex.RPC","ref":"changelog.html#2-10-0","title":"Changelog - 2.10.0","type":"extras"},{"doc":"Added Surgex.Guide.CodeStyle.typespec_alias_usage/0 rule","ref":"changelog.html#2-9-0","title":"Changelog - 2.9.0","type":"extras"},{"doc":"Added Surgex.Config.Patch","ref":"changelog.html#2-8-0","title":"Changelog - 2.8.0","type":"extras"},{"doc":"Added Surgex.Scout to support setting Scout Agent Key with {:system, &quot;SCOUT_API_KEY&quot;}","ref":"changelog.html#2-7-0","title":"Changelog - 2.7.0","type":"extras"},{"doc":"Added Surgex.Guide.SoftwareDesign.return_ok_error_usage/0 rule","ref":"changelog.html#2-6-0","title":"Changelog - 2.6.0","type":"extras"},{"doc":"Fixed Surgex.DeviseSession to support Plug.Conn with {:system, &quot;SECRET_KEY_BASE&quot;}","ref":"changelog.html#2-5-1","title":"Changelog - 2.5.1","type":"extras"},{"doc":"Added Surgex.DatabaseCleaner","ref":"changelog.html#2-5-0","title":"Changelog - 2.5.0","type":"extras"},{"doc":"Added Surgex.Guide.CodeStyle.pipe_chain_alignment/0","ref":"changelog.html#2-3-0","title":"Changelog - 2.3.0","type":"extras"},{"doc":"Fixed Surgex.Parser to return the same error reason multiple times","ref":"changelog.html#2-2-1","title":"Changelog - 2.2.1","type":"extras"},{"doc":"Added support for raw SQL source in Surgex.DataPipe.TableSync","ref":"changelog.html#2-2-0","title":"Changelog - 2.2.0","type":"extras"},{"doc":"Fixed nil scope bug in Surgex.Config.get/2Fixed per-repo config parse bug in Surgex.DataPipe.FollowerSync","ref":"changelog.html#2-1-1","title":"Changelog - 2.1.1","type":"extras"},{"doc":"Added support for per-repo config in Surgex.DataPipe.FollowerSync","ref":"changelog.html#2-1-0","title":"Changelog - 2.1.0","type":"extras"},{"doc":"Replaced Surgex.Config.Session with Surgex.DeviseSessionAdded Surgex.DataPipeAdded Surgex.Refactor","ref":"changelog.html#2-0-0","title":"Changelog - 2.0.0","type":"extras"},{"doc":"Added Surgex.Config.Session","ref":"changelog.html#1-6-0","title":"Changelog - 1.6.0","type":"extras"},{"doc":"Support integer input in Surgex.Parser.IntegerParser","ref":"changelog.html#1-5-2","title":"Changelog - 1.5.2","type":"extras"},{"doc":"Return invalid instead of invalid-cast in Surgex.Changeset","ref":"changelog.html#1-5-1","title":"Changelog - 1.5.1","type":"extras"},{"doc":"Add Surgex.Guide.CodeStyle.test_happy_case_placement/0 rule","ref":"changelog.html#1-5-0","title":"Changelog - 1.5.0","type":"extras"},{"doc":"Keep input nil keys in Surgex.Parser","ref":"changelog.html#1-4-0","title":"Changelog - 1.4.0","type":"extras"},{"doc":"Fix bug in Sentry docs","ref":"changelog.html#1-2-1","title":"Changelog - 1.2.1","type":"extras"},{"doc":"Added Surgex.Guide.SoftwareDesign.error_handling/0 ruleFixed some other rules","ref":"changelog.html#1-2-0","title":"Changelog - 1.2.0","type":"extras"},{"doc":"Added Surgex.PhoneNumber","ref":"changelog.html#1-1-0","title":"Changelog - 1.1.0","type":"extras"},{"doc":"Extended Surgex.Config to support env var listsChanged Surgex.Config to take opts via keyword listAdded Surgex.Parser support for nil inputExtended Surgex.Parser.IntegerParser with min and max optsChanged Surgex.Sentry to run as an OTP appExtended Surgex.Sentry to take release and environment from MixCompleted Surgex.Guide","ref":"changelog.html#1-0-0","title":"Changelog - 1.0.0","type":"extras"}]